<?php

namespace Moblyze\Test\Forms;

class Plan
{
    /**
     * Variable to store form configuration.
     *
     * @var collection
     */
    protected $form;

    /**
     * Variable to store form configuration.
     *
     * @var collection
     */
    protected $element;

    /**
     * Initialize the form.
     *
     * @return null
     */
    public function __construct()
    {
        $this->setForm();
    }

    /**
     * Return form elements.
     *
     * @return array.
     */
    public function form($element = 'fields', $grouped = true)
    {
        $item = collect($this->form->get($element));
        if ($element == 'fields' && $grouped == true) {
            return $item->groupBy(['group', 'section']);
        }
        return $item;

    }

    /**
     * Sets the form and form elements.
     * @return null.
     */
    public function setForm()
    {
        $this->form = collect([
            'form' => [
                'store' => [],
                'update' => [],
            ],
            'groups' => [
                'main' => 'Main',
            ],
            'fields' => [
                'asset_id' => [
                    "type" => 'numeric',
                    "label" => trans('test::plan.label.asset_id'),
                    "placeholder" => trans('test::plan.placeholder.asset_id'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'name' => [
                    "type" => 'text',
                    "label" => trans('test::plan.label.name'),
                    "placeholder" => trans('test::plan.placeholder.name'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'departure_location_id' => [
                    "type" => 'numeric',
                    "label" => trans('test::plan.label.departure_location_id'),
                    "placeholder" => trans('test::plan.placeholder.departure_location_id'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'arrival_location_id' => [
                    "type" => 'numeric',
                    "label" => trans('test::plan.label.arrival_location_id'),
                    "placeholder" => trans('test::plan.placeholder.arrival_location_id'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'waypoint' => [
                    "type" => 'html_editor',
                    "label" => trans('test::plan.label.waypoint'),
                    "placeholder" => trans('test::plan.placeholder.waypoint'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'schedule_time' => [
                    "type" => 'date_time_picker',
                    "label" => trans('test::plan.label.schedule_time'),
                    "placeholder" => trans('test::plan.placeholder.schedule_time'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'purpose_of_journey' => [
                    "type" => 'text',
                    "label" => trans('test::plan.label.purpose_of_journey'),
                    "placeholder" => trans('test::plan.placeholder.purpose_of_journey'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'is_template' => [
                    "type" => 'radios',
                    "label" => trans('test::plan.label.is_template'),
                    "placeholder" => trans('test::plan.placeholder.is_template'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'template_name' => [
                    "type" => 'text',
                    "label" => trans('test::plan.label.template_name'),
                    "placeholder" => trans('test::plan.placeholder.template_name'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'current_latitude' => [
                    "type" => 'decimal',
                    "label" => trans('test::plan.label.current_latitude'),
                    "placeholder" => trans('test::plan.placeholder.current_latitude'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
                'current_longitude' => [
                    "type" => 'decimal',
                    "label" => trans('test::plan.label.current_longitude'),
                    "placeholder" => trans('test::plan.placeholder.current_longitude'),
                    "rules" => '',
                    "group" => "main",
                    "section" => "first",
                    "attributes" => [
                        'wrapper' => [],
                        "label" => [],
                        "input" => [],

                    ],
                ],
            ]
        );

    }
}
